const ipcRenderer = require('electron').ipcRenderer
const {desktopCapturer} = require('electron')

let mediaStream

function getDefaultStream(event) {
  console.log('getDefaultStream')
  desktopCapturer.getSources({types: ['window', 'screen']}, (error, sources) => {
    if (error) {
      console.log(error)
      return
    }
    for (let i = 0; i < sources.length; ++i) {
      if (sources[i].name === 'Screen 1') {
        navigator.mediaDevices.getUserMedia({
          audio: false,
          video: {
            mandatory: {
              chromeMediaSource: 'desktop',
              chromeMediaSourceId: sources[i].id,
              minWidth: 1280,
              maxWidth: 1280,
              minHeight: 720,
              maxHeight: 720
            }
          }
        }).then((stream) => {
          mediaStream = stream
          console.log('sending defaultStreamResponse' + stream)
          event.sender.send('defaultStreamResponse', stream)
        })
      }
    }
    return
  })
}

ipcRenderer.on('defaultStreamRequest', (event, message) => {
  console.log('defaultStreamRequest received, grabbing media stream for screen1')
  getDefaultStream(event)
})
